# Main load function

gamerule maxCommandChainLength 2147483647
gamerule doDaylightCycle false
gamerule doWeatherCycle false
difficulty peaceful

schedule function mver:ref/second_loop 1s replace

scoreboard objectives add MVER_Version dummy
scoreboard objectives add MVER_UpdateData dummy
scoreboard objectives add MVER_Unlocks dummy
scoreboard objectives add birch_wood_mined minecraft.mined:minecraft.birch_wood
#define storage mver:update

schedule clear mver:update/entities/looped_check/main
data modify storage mver:update checking_entities_master set value []

# Place all structures on first load
execute unless score #setup MVER_UpdateData matches 1.. run function mver:first_load

# Check for updates -  #debug_flag can be set manually before a reload to prevent the structures from updating
execute if score #setup MVER_UpdateData matches 1 unless score #debug_flag MVER_UpdateData matches 1 run function mver:init/initialise_structure_data
execute if score #setup MVER_UpdateData matches 1 unless score #debug_flag MVER_UpdateData matches 1 if data storage mver:update structures[0] run function mver:update/structures/loop

execute if score #setup MVER_UpdateData matches 1 unless score #debug_flag MVER_UpdateData matches 1 run function mver:init/initialise_entity_data
execute if score #setup MVER_UpdateData matches 1 unless score #debug_flag MVER_UpdateData matches 1 if data storage mver:update entities[0] run function mver:update/entities/loop

scoreboard players set #setup MVER_UpdateData 1

# Update version to this version of the pack - has to happen after checking for updates
scoreboard players set $internal_version MVER_Version 2

tellraw @a {"fallback":"Please install the Minevolution Evo-Reborn Resource pack for the best experience!","translate":"mver.initialization.rp.test"}
tellraw @a {"fallback":"MISSMATCHED VERSIONS: YOUR MVER RESOURCE PACK IS OUT OF DATE AND MAY BE MISSING ESSENTIAL ASSETS!!! PLEASE UPDATE ON THE MODRINTH PAGE!!!","translate":"mver.initialization.rp.test.devversion.1"}

schedule function mver:update/entities/looped_check/main 1s