# Set the `#force_update` score flag to 1 to force place all the loaded 
# entities - used on first load

execute store result score #min_version MVER_Version run data get storage mver:update entities[0].min_compatible
scoreboard players operation #max_compatible MVER_Version = $internal_version MVER_Version
execute if data storage mver:update entities[0].max_compatible store result score #max_compatible MVER_Version run data get storage mver:update entities[0].max_compatible

# Version check to remove
execute store result score #do_kill MVER_UpdateData if score $internal_version MVER_Version > #max_compatible MVER_Version
execute if score #do_kill MVER_UpdateData matches 1 run data modify storage mver:update macro merge from storage mver:update entities[0]
execute if score #do_kill MVER_UpdateData matches 1 run function mver:update/entities/kill with storage mver:update macro
execute if score #do_kill MVER_UpdateData matches 1 run data remove storage mver:update entities[0]
execute if score #do_kill MVER_UpdateData matches 1 if data storage mver:update entities[0] run return run function mver:update/entities/loop
execute if score #do_kill MVER_UpdateData matches 1 run return 0

# Version check to update/replace
execute if score dev MVER_Version matches 1 run scoreboard players set #force_update MVER_UpdateData 1
execute unless score #force_update MVER_UpdateData matches 1 store result score #do_update MVER_UpdateData if score $internal_version MVER_Version < #min_version MVER_Version
execute if score #force_update MVER_UpdateData matches 1 run scoreboard players set #do_update MVER_UpdateData 1

execute if score #do_update MVER_UpdateData matches 0 run data remove storage mver:update entities[0]
execute if score #do_update MVER_UpdateData matches 0 if data storage mver:update entities[0] run return run function mver:update/entities/loop
execute if score #do_update MVER_UpdateData matches 0 run return 0

# Execute update/replace
data modify storage mver:update macro merge from storage mver:update entities[0]
execute store result score $do_check MVER_UpdateData if data storage mver:update macro.score_req
execute unless score $do_check MVER_UpdateData matches 0 unless data storage mver:update macro.score_check run data modify storage mver:update macro.score_check set value 1
execute unless score $do_check MVER_UpdateData matches 0 unless data storage mver:update macro.score_cond run data modify storage mver:update macro.score_cond set value "if"
execute unless score $do_check MVER_UpdateData matches 0 run function mver:update/entities/update_entity_score_check with storage mver:update macro
execute if score $do_check MVER_UpdateData matches 0 run function mver:update/entities/update_entity with storage mver:update macro
data remove storage mver:update macro

data remove storage mver:update entities[0]
execute if data storage mver:update entities[0] run return run function mver:update/entities/loop
return 0